<template>
  <div>
    <div class="init-components">
      <div id="container-connections">
        <Connections />
      </div>
      <div id="container-properties">
        <Properties :set-properties="setProperties" />
      </div>
      <div id="container-work-tabs">
        <WorkTabs :properties="properties" />
      </div>
    </div>
    <JqxLayout
      :theme="theme"
      :width="'100%'"
      :height="heightDock"
      ref="DockingLayout"
      :layout="layout()"
    >
      <div data-container="Connections">
        <div id="connections" ref="connections"></div>
      </div>
      <div data-container="PropertiesPanel">
        <div id="properties" ref="properties"></div>
      </div>
      <div data-container="WorkTabs">
        <div id="work-tabs" ref="workTabs"></div>
      </div>
    </JqxLayout>
  </div>
</template>
<style scoped>
@import "~jqwidgets-scripts/jqwidgets/styles/jqx.base.css";
@import "~jqwidgets-scripts/jqwidgets/styles/jqx.material.css";
/*@import "~jqwidgets-scripts/jqwidgets/styles/jqx.oranges.css";*/
.init-components {
  display: none;
}
</style>
<script>
import JqxLayout from "jqwidgets-scripts/jqwidgets-vue/vue_jqxlayout.vue";
import Connections from "@/views/secure/pro/Connections.vue";
import Properties from "@/views/secure/pro/Properties.vue";
import WorkTabs from "@/views/secure/pro/WorkTabs.vue";
export default {
  name: "Component-Ide",
  components: {
    JqxLayout,
    WorkTabs,
    Connections,
    Properties
  },
  data: () => ({
    properties: null,
    heightDock: 700,
    widthMainContainer: 800,
    theme: "orange"
  }),
  methods: {
    layout() {
      const layout = [
        {
          type: "layoutGroup",
          orientation: "horizontal",
          alignment: "left",
          items: [
            {
              type: "tabbedGroup",
              width: 300,
              minWidth: 250,
              pinnedWidth: 150,
              items: [
                {
                  type: "layoutPanel",
                  title: "Conexiones",
                  contentContainer: "Connections",
                  initContent: () => {
                    let connections = document.getElementById("connections");
                    let containerConnections = document.getElementById(
                      "container-connections"
                    );
                    connections.appendChild(containerConnections);
                  }
                },
                {
                  type: "layoutPanel",
                  title: "Propiedades",
                  contentContainer: "PropertiesPanel",
                  disabled: true,
                  initContent: () => {
                    let properties = document.getElementById("properties");
                    let containerProperties = document.getElementById(
                      "container-properties"
                    );
                    properties.appendChild(containerProperties);
                  }
                }
              ]
            },
            {
              type: "layoutGroup",
              orientation: "vertical",
              width: this.widthMainContainer,
              minWidth: 500,
              items: [
                {
                  type: "documentGroup",
                  height: this.heightDock,
                  minHeight: 200,
                  items: [
                    {
                      type: "documentPanel",
                      title: "Trabajo",
                      contentContainer: "WorkTabs",
                      initContent: () => {
                        let workTabs = document.getElementById("work-tabs");
                        let containerWorkTabs = document.getElementById(
                          "container-work-tabs"
                        );
                        workTabs.appendChild(containerWorkTabs);
                      }
                    }
                  ]
                }
              ]
            }
          ]
        }
      ];
      return layout;
    },
    resizeHandler() {
      this.heightDock = this.$el.parentElement.offsetHeight;
      this.widthMainContainer = this.$el.parentElement.offsetWidth;
      this.$refs["DockingLayout"].height = this.heightDock - 15;
    },
    setProperties(properties) {
      this.properties = properties;
    }
  },
  beforeMount() {
    this.widthMainContainer = window.innerWidth - 306;
  },
  mounted() {
    this.heightDock = this.$el.parentElement.offsetHeight;
    this.widthMainContainer = this.$el.parentElement.offsetWidth;
    this.$refs["DockingLayout"].height = this.heightDock - 15;
    window.addEventListener("resize", this.resizeHandler);
  }
};
</script>
